<!--

STOP ! ! !

Read the following before creating anything (or you will have your issue/feature request closed without notice)

1. Please only create an ISSUE or a FEATURE REQUEST - don't mix the two together in one item
2. For a Feature Request please only fill out the FEATURE REQUEST section
3. For a Issue please only fill out the ISSUE section
4. Issues are NOT to be used for help/config problems/support - use the relevant slack channels as per the README
5. Provide a good summary in the title, don't just write problem, or awesome idea!
6. Delete all irrelevant sections not related to your issue/feature request (including this top section)

===============ISSUE SECTION===============

Before you create an Issue, please check the following:

1. Have you validated that your config.json is valid JSON? Use http://jsonlint.com/ to check.
2. Have you [searched our issue tracker](https://github.com/PokemonGoF/PokemonGo-Bot/issues?q=is%3Aissue+sort%3Aupdated-desc) to see if the issue already exists? If so, comment on that issue instead rather than creating a new issue.
3. Are you running on the `master` branch? We work on the `dev` branch and then add that functionality to `master` when it is stable. Your issue may be fixed on `dev` and there is no need for this issue, just wait and it will eventually be merged to `master`.
4. All Issue sections MUST be completed to help us determine the actual problem and find its cause
-->
### Expected Behavior
<!-- Tell us what you expect to happen -->


### Actual Behavior
<!-- Tell us what is happening -->


### Your FULL config.json (remove your username, password, gmapkey and any other private info)
<!-- Provide your FULL config file, feel free to use services such as pastebin.com to reduce clutter -->


### Output when issue occurred
<!-- Provide a reasonable sample from your output log (not just the error message), feel free to use services such as pastebin.com to reduce clutter -->


### Steps to Reproduce
<!-- Tell us the steps you have taken to reproduce the issue -->


### Other Information
OS: 
<!-- Tell us what Operating system you're using --> 
Branch: 
<!-- dev or master --> 
Git Commit: 
<!-- run 'git log -n 1 --pretty=format:"%H"' --> 
Python Version: 
<!-- run 'python -V' and paste it here) --> 
Any other relevant files/configs (eg: path files) 
<!-- Anything else which may be of relevance -->

<!-- ===============END OF ISSUE SECTION=============== -->
<!-- Note: Delete these lines and everything BELOW if creating an Issue -->




<!-- ===============FEATURE REQUEST SECTION===============

Before you create a Feature Request, please check the following:

1. Have you [searched our feature tracker](https://github.com/PokemonGoF/PokemonGo-Bot/labels/Feature%20Request) first to ensure someone else hasn't already come up with the same great idea.  If so then be sure to +1 it 
2. While you're there, be sure to vote on other feature requests to let the devs know what is important to you.
-->

<!-- Note: Delete this line and everything ABOVE if creating a Feature Request -->
### Short Description
<!-- Tell us a short description of your request -->


### Possible solution
<!-- Tell us how you would include it in the current bot -->


### How it would help others
<!-- Tell us how you think it would help yourself and other users -->


<!-- ==========END OF FEATURE REQUEST SECTION========== -->
